Debian Bug report logs - #397616
[arm] /proc/cpu/alignment should default to warn and fixup on arm

Package: linux-2.6; Maintainer for linux-2.6 is Debian Kernel Team <debian-kernel@lists.debian.org>;

Reported by: Sjoerd Simons <sjoerd@debian.org>

Date: Wed, 8 Nov 2006 13:18:02 UTC

Severity: normal

Done: Martin Michlmayr <tbm@cyrius.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-arm@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Sjoerd Simons <sjoerd@debian.org>:
New Bug report received and forwarded. Copy sent to debian-arm@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Sjoerd Simons <sjoerd@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: /proc/cpu/alignment should default to warn and fixup on arm
Date: Wed, 08 Nov 2006 14:02:53 +0100
Package: linux-2.6
Severity: normal

Hi,
  
  By default the ARM kernel just ignores unaligned accesses from
  userspace and can just accesses another address then actually
  specified. This can cause strange behaviour by userspace programs.
  While i agree that these programs are somewhat buggy, but doing
  something undefined and not telling anyone doesn't seem like a good
  strategy :)

  Some discussion on #debian-arm indicates that it the current default
  made some sense in the old days. Where some programs actually relied
  on the behaviour and the amount of buggy programs was so big that it
  actually caused a flood of warnings. 
  
  Times have changed though, no applications in debian should depend on
  this behaviour and turning on warn+fixup doesn't seem cause a flood
  anymore.  Most problemeatic should have been fixed by now, as on Sparc
  you'll get a sigbus on unaligned access and iirc Alpha gives a warning 
  about it.

  For reference, i discovered this issue because powerdns on my arm was
  giving out weird SOA records. So enabling fixup does solves real
  problems or at least shows where they are :) (Yes i've already patched
  pdns and will be sending the patch out after some more testing)

  Sjoerd

-- System Information:
Debian Release: testing/unstable
  APT prefers testing
  APT policy: (500, 'testing'), (101, 'unstable')
Architecture: arm (armv5tel)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.18-1-iop32x
Locale: LANG=C, LC_CTYPE=nl_NL (charmap=ISO-8859-1)



Changed Bug title. Request was from Sven Luther <sven.luther@wanadoo.fr> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #12 received at 397616@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Wed, 8 Nov 2006 18:46:38 +0000
* Sjoerd Simons <sjoerd@debian.org> [2006-11-08 14:02]:
>   Some discussion on #debian-arm indicates that it the current default

Can you make logs of that discussion available?
-- 
Martin Michlmayr
http://www.cyrius.com/



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to sjoerd@spring.luon.net (Sjoerd Simons):
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #17 received at 397616@bugs.debian.org (full text, mbox):

From: sjoerd@spring.luon.net (Sjoerd Simons)
To: Martin Michlmayr <tbm@cyrius.com>
Cc: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Wed, 8 Nov 2006 21:07:20 +0100
On Wed, Nov 08, 2006 at 06:46:38PM +0000, Martin Michlmayr wrote:
> * Sjoerd Simons <sjoerd@debian.org> [2006-11-08 14:02]:
> >   Some discussion on #debian-arm indicates that it the current default
> 
> Can you make logs of that discussion available?

Sure, wookey had some extra comments after i asked for permission to post it so
i've added those too:
  http://beast.luon.net/~sjoerd/arm_unaligned.log

  Sjoerd
-- 
The amount of time between slipping on the peel and landing on the
pavement is precisely 1 bananosecond.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #22 received at 397616@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Wed, 8 Nov 2006 20:57:34 +0000
* Sjoerd Simons <sjoerd@spring.luon.net> [2006-11-08 21:07]:
> Sure, wookey had some extra comments after i asked for permission to post it so
> i've added those too:
>   http://beast.luon.net/~sjoerd/arm_unaligned.log

http://netwinder.osuosl.org/users/b/brianbr/public_html/alignment.html

Ok, thanks for the pointer.  I don't think it's a good idea to enable
this right now, but we should do it after etch is out.
-- 
Martin Michlmayr
http://www.cyrius.com/



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #27 received at 397616@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Sun, 11 Nov 2007 19:26:28 +0100
* Sjoerd Simons <sjoerd@debian.org> [2006-11-08 14:02]:
>   By default the ARM kernel just ignores unaligned accesses from
>   userspace and can just accesses another address then actually
>   specified. This can cause strange behaviour by userspace programs.
...

Nothing has been done with regards to this bug.  I suggest that unless
you can get upstream to change the behaviour we won't change it
either.
-- 
Martin Michlmayr
http://www.cyrius.com/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #32 received at 397616@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Cc: riku.voipio@iki.fi
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Fri, 25 Apr 2008 15:12:08 +0700
I'd like to hear Riku's opinion on this.

But I'm inclined not to move away from the upstream default, although
I must admit that Sjoerd has good arguments for changing it.

Maybe you could ask upstream whether it's time to change the default
to a warning?


* Sjoerd Simons <sjoerd@debian.org> [2006-11-08 14:02]:
> Package: linux-2.6
> Severity: normal
> 
> Hi,
>   
>   By default the ARM kernel just ignores unaligned accesses from
>   userspace and can just accesses another address then actually
>   specified. This can cause strange behaviour by userspace programs.
>   While i agree that these programs are somewhat buggy, but doing
>   something undefined and not telling anyone doesn't seem like a good
>   strategy :)
> 
>   Some discussion on #debian-arm indicates that it the current default
>   made some sense in the old days. Where some programs actually relied
>   on the behaviour and the amount of buggy programs was so big that it
>   actually caused a flood of warnings. 
>   
>   Times have changed though, no applications in debian should depend on
>   this behaviour and turning on warn+fixup doesn't seem cause a flood
>   anymore.  Most problemeatic should have been fixed by now, as on Sparc
>   you'll get a sigbus on unaligned access and iirc Alpha gives a warning 
>   about it.
> 
>   For reference, i discovered this issue because powerdns on my arm was
>   giving out weird SOA records. So enabling fixup does solves real
>   problems or at least shows where they are :) (Yes i've already patched
>   pdns and will be sending the patch out after some more testing)
> 
>   Sjoerd
> 
> -- System Information:
> Debian Release: testing/unstable
>   APT prefers testing
>   APT policy: (500, 'testing'), (101, 'unstable')
> Architecture: arm (armv5tel)
> Shell:  /bin/sh linked to /bin/bash
> Kernel: Linux 2.6.18-1-iop32x
> Locale: LANG=C, LC_CTYPE=nl_NL (charmap=ISO-8859-1)
> 
> 
> -- 
> To UNSUBSCRIBE, email to debian-arm-REQUEST@lists.debian.org
> with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org

-- 
Martin Michlmayr
http://www.cyrius.com/




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to "Martin Guy" <martinwguy@yahoo.it>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #37 received at 397616@bugs.debian.org (full text, mbox):

From: "Martin Guy" <martinwguy@yahoo.it>
To: 397616@bugs.debian.org
Date: Wed, 30 Apr 2008 11:17:09 +0100
In order of preference
2 or 3: fixup misaligned accesses
4 or 5: SIGBUS the process in question, rather than silently giving
the wrong results (it is the same logic as dividing by zero or
accessing memory through an invalid pointer).
0 or 1: silently give wrong results.

I'm afraid the linked IRC discussion has disappeared from the web and
is not on archive.org - in any case, mailing lists are the place to
hold open source discussions, both so that it is archived and to avoid
"select inner group" false consensus among the few people who happen
to be awake and hanging out on IRC at the time.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Riku Voipio <riku.voipio@iki.fi>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #42 received at 397616@bugs.debian.org (full text, mbox):

From: Riku Voipio <riku.voipio@iki.fi>
To: Martin Michlmayr <tbm@cyrius.com>
Cc: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Sun, 4 May 2008 22:07:47 +0300
I think this should be pushed via upstream. In the following
thread, it seems to be concluded that 1) fixups should be default
2) warnings can cause bad side-effects (imagine a unaligned
error in sysklogd..)

http://thread.gmane.org/gmane.linux.ports.arm.kernel/34044

On Fri, Apr 25, 2008 at 03:12:08PM +0700, Martin Michlmayr wrote:
> I'd like to hear Riku's opinion on this.
> 
> But I'm inclined not to move away from the upstream default, although
> I must admit that Sjoerd has good arguments for changing it.
> 
> Maybe you could ask upstream whether it's time to change the default
> to a warning?
> 
> 
> * Sjoerd Simons <sjoerd@debian.org> [2006-11-08 14:02]:
> > Package: linux-2.6
> > Severity: normal
> > 
> > Hi,
> >   
> >   By default the ARM kernel just ignores unaligned accesses from
> >   userspace and can just accesses another address then actually
> >   specified. This can cause strange behaviour by userspace programs.
> >   While i agree that these programs are somewhat buggy, but doing
> >   something undefined and not telling anyone doesn't seem like a good
> >   strategy :)
> > 
> >   Some discussion on #debian-arm indicates that it the current default
> >   made some sense in the old days. Where some programs actually relied
> >   on the behaviour and the amount of buggy programs was so big that it
> >   actually caused a flood of warnings. 
> >   
> >   Times have changed though, no applications in debian should depend on
> >   this behaviour and turning on warn+fixup doesn't seem cause a flood
> >   anymore.  Most problemeatic should have been fixed by now, as on Sparc
> >   you'll get a sigbus on unaligned access and iirc Alpha gives a warning 
> >   about it.
> > 
> >   For reference, i discovered this issue because powerdns on my arm was
> >   giving out weird SOA records. So enabling fixup does solves real
> >   problems or at least shows where they are :) (Yes i've already patched
> >   pdns and will be sending the patch out after some more testing)
> > 
> >   Sjoerd
> > 
> > -- System Information:
> > Debian Release: testing/unstable
> >   APT prefers testing
> >   APT policy: (500, 'testing'), (101, 'unstable')
> > Architecture: arm (armv5tel)
> > Shell:  /bin/sh linked to /bin/bash
> > Kernel: Linux 2.6.18-1-iop32x
> > Locale: LANG=C, LC_CTYPE=nl_NL (charmap=ISO-8859-1)
> > 
> > 
> > -- 
> > To UNSUBSCRIBE, email to debian-arm-REQUEST@lists.debian.org
> > with a subject of "unsubscribe". Trouble? Contact listmaster@lists.debian.org
> 
> -- 
> Martin Michlmayr
> http://www.cyrius.com/

-- 
"rm -rf" only sounds scary if you don't have backups




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Kernel Team <debian-kernel@lists.debian.org>:
Bug#397616; Package linux-2.6. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Debian Kernel Team <debian-kernel@lists.debian.org>. Full text and rfc822 format available.

Message #47 received at 397616@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Riku Voipio <riku.voipio@iki.fi>
Cc: Sjoerd Simons <sjoerd@debian.org>, 397616@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Tue, 6 May 2008 17:40:20 +0200
* Riku Voipio <riku.voipio@iki.fi> [2008-05-04 22:07]:
> 2) warnings can cause bad side-effects (imagine a unaligned
> error in sysklogd..)
> 
> http://thread.gmane.org/gmane.linux.ports.arm.kernel/34044

I think that's a good argument for not changing the upstream default.
So I think we should close this bug report and someone should take
this up with upstream (not me).  Any volunteers?

-- 
Martin Michlmayr
http://www.cyrius.com/




Reply sent to Martin Michlmayr <tbm@cyrius.com>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Sjoerd Simons <sjoerd@debian.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #52 received at 397616-done@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Riku Voipio <riku.voipio@iki.fi>
Cc: Sjoerd Simons <sjoerd@debian.org>, 397616-done@bugs.debian.org
Subject: Re: Bug#397616: /proc/cpu/alignment should default to warn and fixup on arm
Date: Sun, 3 Aug 2008 09:04:12 +0300
* Martin Michlmayr <tbm@cyrius.com> [2008-05-06 17:40]:
> > 2) warnings can cause bad side-effects (imagine a unaligned
> > error in sysklogd..)
> > http://thread.gmane.org/gmane.linux.ports.arm.kernel/34044
> 
> I think that's a good argument for not changing the upstream default.
> So I think we should close this bug report and someone should take
> this up with upstream (not me).  Any volunteers?

Someone tried to raise this with upstream recently; here's the reply:

http://lists.arm.linux.org.uk/lurker/message/20080801.160843.c7b80fb6.en.html

Closing this bug report.
-- 
Martin Michlmayr
http://www.cyrius.com/




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 31 Aug 2008 07:27:30 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 25 02:11:03 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.